import numpy as np
import matplotlib.pyplot as plt
from mpl_toolkits.mplot3d import Axes3D

def showPointClouds(P,Q,idxp, idxq):
    plt.cla()
    ax = fig.add_subplot(111, projection='3d')
    ax.scatter(P[0, ::5], P[1, ::5], P[2, ::5], c='r', s=5, marker='.')
    ax.scatter(Q[0, ::5], Q[1, ::5], Q[2, ::5], c='k', s=5, marker='.')
    #ax.scatter(P[0, :], P[1, :], P[2, :], s=5, c='b')
    #ax.scatter(Q[0, :], Q[1, :], Q[2, :], s=5, c='g')
    #for i in range(0, idxp.shape[0]):
       # ax.plot3D([P[0, idxp[i]],Q[0, idxq[i]]], [P[1, idxp[i]],Q[1, idxq[i]]], [P[2, idxp[i]],Q[2, idxq[i]]], color='b')
       # ax.scatter(P[0, idxp[i]], P[1, idxp[i]], P[2, idxp[i]], s=5, c='r', marker='o')
       # ax.scatter(Q[0, idxq[i]], Q[1, idxq[i]], Q[2, idxq[i]], s=5, c='k', marker='o')
    ax.set_xlim(-1.5, 1.5)
    ax.set_ylim(-1.5, 1.5)
    ax.set_zlim(0.5, 2.5)

# Ini
P0 = np.load('P0.npy')
Q0 = np.load('Q0.npy')
P = P0.copy()
Q = Q0.copy()



fig = plt.figure()
showPointClouds(P,Q, np.array([]), np.array([]))

# plt.close()

##### ICP loop ######

for t in range(0,20):
    # Select random subset of points from P
    idxp = ...

    # Find nearest neighbours in Q
    idxq = ...

    # Shift P to mean(P[:,idxp]) and Q to mean(Q0[:,idxq])
    P = ...
    Q = ...

    # Estimate rotation and translation
    R = ...
    T = ...

    # Transform pointcloud P to R*P+T
    P = ...

    # Compute alignment error
    print('Mean Euclidean distance: %.4f' % np.mean(np.linalg.norm(P[:, idxp] - Q0[:, idxq], axis=0)))

    # Show pointclouds
    showPointClouds(P, Q0, idxp, idxq)

#######################